// Filter.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "Filter.h"

#include "Globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilter

CFilter::CFilter()
{
}

CFilter::~CFilter()
{
}


BEGIN_MESSAGE_MAP(CFilter, CWnd)
	//{{AFX_MSG_MAP(CFilter)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CFilter message handlers

BOOL CFilter::ContractsFilter(CData * pDb, CString col, CString op, CString val, BOOL cnt, int & count)
{
	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Close();

	CString str = col+ " " +op+ "'" +val+ "'";

	pDb->m_contractsSet.m_strFilter = str;
	pDb->m_contractsSet.m_strSort = col;

	pDb->m_contractsSet.Open();

	count = pDb->m_contractsSet.GetRecordCount();

	if(count == 0)
		return FALSE;

	else
	{
		if(cnt)
		{
			pDb->m_contractsSet.MoveFirst();
			while(!pDb->m_contractsSet.IsEOF())
			{
				count++;
				pDb->m_contractsSet.MoveNext();
			}
		}

		return TRUE;
	}




	return TRUE;
}

BOOL CFilter::ContractsFilter(CData * pDb, CString col, CString op, COleDateTime val, BOOL cnt, int & count)
{
	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Open();

	pDb->m_contractsSet.m_strFilter = BuildSQL(pDb, col, op, 1);
	SetValue(pDb, col, val);






	return TRUE;
}

BOOL CFilter::ContractsFilter(CData * pDb, CString col, CString op, BOOL val, BOOL cnt, int & count)
{
	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Close();

	pDb->m_contractsSet.m_strFilter = BuildSQL(pDb, col, op, 1);
	SetValue(pDb, col, val);

	pDb->m_contractsSet.Open();

	count = pDb->m_contractsSet.GetRecordCount();

	if(count == 0)
		return FALSE;

	else
	{
		if(cnt)
		{
			pDb->m_contractsSet.MoveFirst();
			while(!pDb->m_contractsSet.IsEOF())
			{
				count++;
				pDb->m_contractsSet.MoveNext();
			}
		}
		return TRUE;
	}
}

BOOL CFilter::ContractsFilter(CData * pDb, CString col, CString op, COleDateTime val)
{
	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Close();

	pDb->m_contractsSet.m_strFilter = BuildSQL(pDb, col, op, 1);
	SetValue(pDb, col, val);

	pDb->m_contractsSet.Open();

	int count = pDb->m_contractsSet.GetRecordCount();

	if(count == 0)
		return FALSE;

	else
		return TRUE;
}

BOOL CFilter::ContractsFilter(CData * pDb, CString col, CString op, BOOL val)
{
	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Close();

	pDb->m_contractsSet.m_strFilter = BuildSQL(pDb, col, op, 1);
	SetValue(pDb, col, val);

	pDb->m_contractsSet.Open();

	int count = pDb->m_contractsSet.GetRecordCount();

	if(count == 0)
		return FALSE;
	else
		return TRUE;
}

BOOL CFilter::ContractsFilter(CData * pDb, CString col, CString op, CString val)
{
	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Close();

	CString str = col+ " " +op+ "'" +val+ "'";

	pDb->m_contractsSet.m_strFilter = str;
	//pDb->m_contractsSet.m_strSort = col;

	pDb->m_contractsSet.Open();

	int count = pDb->m_contractsSet.GetRecordCount();

	if(count == 0)
		return FALSE;

	else
		return TRUE;
}

CString CFilter::BuildSQL(CData *pDb, CString col, CString op, int q)
{
	int itor;
	CString str;

	if(q != -1)
	{
		str = col+ " " +op+ " ?";
		q--;
		for(itor = 0; itor < q; itor++)
			str += ", ?";

	}
	else
		str = col+ " " +op+ "'";

	return str;
}

void CFilter::SetValue(CData * pDb, CString col, COleDateTime val)
{
	if(col == "val_first_tckt")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_FIRST_TCKT);
		pDb->m_contractsSet.SetParamValue(CONTRACT_VAL_FIRST_TCKT, val);
	}
	else if(col == "val_first_travel")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_FIRST_TRAVEL);
		pDb->m_contractsSet.SetParamValue(CONTRACT_VAL_FIRST_TRAVEL, val);
	}
	else if(col == "val_last_tckt")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_LAST_TCKT);
		pDb->m_contractsSet.SetParamValue(CONTRACT_VAL_LAST_TCKT, val);
	}
	else if(col == "val_last_travel")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_LAST_TRAVEL);
		pDb->m_contractsSet.SetParamValue(CONTRACT_VAL_LAST_TRAVEL, val);
	}
	else if(col == "val_exp_yr")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_EXP_YR);
		pDb->m_contractsSet.SetParamValue(CONTRACT_VAL_EXP_YR, val);
	}
	else if(col == "update_date")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_UPDATE_DATE);
		pDb->m_contractsSet.SetParamValue(CONTRACT_UPDATE_DATE, val);
	}
}

void CFilter::SetValue(CData * pDb, CString col, BOOL val)
{
	if(col == "hot_deal")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_HOT_DEAL);
		pDb->m_contractsSet.m_hot_dealParam = val;
	}
	else if(col == "air_deals_notebook")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_AIR_DEALS_NOTEBOOK);
		pDb->m_contractsSet.m_air_deals_notebookParam = val;
	}
	else if(col == "md_us")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_US);
		pDb->m_contractsSet.m_md_usParam = val;
	}
	else if(col == "md_eu")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_EU);
		pDb->m_contractsSet.m_md_euParam = val;
	}
	else if(col == "md_asia")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_ASIA);
		pDb->m_contractsSet.m_md_asiaParam = val;
	}
	else if(col == "md_south_pacific")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_SOUTH_PACIFIC);
		pDb->m_contractsSet.m_md_south_pacificParam = val;
	}
	else if(col == "md_south_am")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_SOUTH_AM);
		pDb->m_contractsSet.m_md_south_amParam = val;
	}
	else if(col == "md_central_am")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_CENTRAL_AM);
		pDb->m_contractsSet.m_md_central_amParam = val;
	}
	else if(col == "md_latin_am")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_LATIN_AM);
		pDb->m_contractsSet.m_md_latin_amParam = val;
	}
	else if(col == "md_mexico")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_MEXICO);
		pDb->m_contractsSet.m_md_mexicoParam = val;
	}
	else if(col == "md_africa")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_AFRICA);
		pDb->m_contractsSet.m_md_africaParam = val;
	}
	else if(col == "md_ca")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_CA);
		pDb->m_contractsSet.m_md_caParam = val;
	}
	else if(col == "md_middle_east")
	{	
		pDb->m_contractsSet.SetNull(CONTRACT_MD_MIDDLE_EAST);
		pDb->m_contractsSet.m_md_middle_eastParam = val;
	}
	else if(col == "md_russia")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_MD_RUSSIA);
		pDb->m_contractsSet.m_md_russiaParam = val;
	}
	else if(col == "good_for_all")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_GOOD_FOR_ALL);
		pDb->m_contractsSet.m_good_for_allParam = val;
	}
	else if(col == "good_for_MTALL")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_GOOD_FOR_MTALL);
		pDb->m_contractsSet.m_good_for_MTALLParam = val;
	}
	else if(col == "good_for_MTLELS")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_GOOD_FOR_MTLELS);
		pDb->m_contractsSet.m_good_for_MTLELSParam = val;
	}
	else if(col == "good_for_MTCorp")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_GOOD_FOR_MTCORP);
		pDb->m_contractsSet.m_good_for_MTCorpParam = val;
	}
	else if(col == "good_for_A4L")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_GOOD_FOR_A4L);
		pDb->m_contractsSet.m_good_for_A4LParam = val;
	}
	else if(col == "good_for_ST")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_GOOD_FOR_ST);
		pDb->m_contractsSet.m_good_for_STParam = val;
	}
	else if(col == "type_deal_pcomm")
	{	
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_PCOMM);
		pDb->m_contractsSet.m_type_deal_pcommParam = val;
	}
	else if(col == "type_deal_pdisc")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_PDISC);
		pDb->m_contractsSet.m_type_deal_pdiscParam = val;
	}
	else if(col == "type_deal_dcomm")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_DCOMM);
		pDb->m_contractsSet.m_type_deal_dcommParam = val;
	}
	else if(col == "type_deal_ddisc")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_DDISC);
		pDb->m_contractsSet.m_type_deal_ddiscParam = val;
	}
	else if(col == "type_deal_zone")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_ZONE);
		pDb->m_contractsSet.m_type_deal_zoneParam = val;
	}
	else if(col == "type_deal_bulk")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_BULK);
		pDb->m_contractsSet.m_type_deal_bulkParam = val;
	}
	else if(col == "type_deal_net")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_NET);
		pDb->m_contractsSet.m_type_deal_netParam = val;
	}
	else if(col == "type_deal_upgrade")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_UPGRADE);
		pDb->m_contractsSet.m_type_deal_upgradeParam = val;
	}
	else if(col == "type_deal_two_one")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_TWO_ONE);
		pDb->m_contractsSet.m_type_deal_two_oneParam = val;
	}
	else if(col == "type_deal_other")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_TYPE_DEAL_OTHER);
		pDb->m_contractsSet.m_type_deal_otherParam = val;
	}
	else if(col == "val_start")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_START);
		pDb->m_contractsSet.m_val_startParam = val;
	}
	else if(col == "val_complete")
	{
		pDb->m_contractsSet.SetNull(CONTRACT_VAL_COMPLETE);
		pDb->m_contractsSet.m_val_completeParam = val;
	}
	else
		MessageBox("You forgot one");

}

CString CFilter::BuildSQL(CAll * a)
{
	CString str = "SELECT * FROM contracts WHERE ";

	int itor;
	int type;
	CString op, conj;
	int codt_col, cstring_col, bool_col;
	BOOL bl_val, get_type_ok, get_bool_ok, get_cstring_ok, get_codt_ok;
	COleDateTime codt_val;
	CString str_val;
	

	for(itor = 0; itor <= a->GetMax(); itor++)
	{
		get_type_ok = a->Get(itor, type);

		if(get_type_ok)
		{
			switch(type)
			{
			case CT_COLEDATETIME:
				{
					get_codt_ok = a->Get(itor, codt_col, op, conj, codt_val);
					if(get_codt_ok)
					{
						switch(codt_col)
						{
						case CONTRACT_VAL_FIRST_TCKT:
							{
								str += "val_first_tckt";
								str += " " +op+ " ";
								str += codt_val.Format(VAR_DATEVALUEONLY, LANG_USER_DEFAULT);
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_VAL_FIRST_TRAVEL:
							{
								str += "val_first_travel";
								str += " " +op+ " ";
								str += codt_val.Format(VAR_DATEVALUEONLY, LANG_USER_DEFAULT);
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_VAL_LAST_TCKT:
							{
								str += "val_last_tckt";
								str += " " +op+ " ";
								str += codt_val.Format(VAR_DATEVALUEONLY, LANG_USER_DEFAULT);
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_VAL_LAST_TRAVEL:
							{
								str += "val_last_travel";
								str += " " +op+ " ";
								str += codt_val.Format(VAR_DATEVALUEONLY, LANG_USER_DEFAULT);
								str += " " +conj+ " ";
							}
							break;					
						case CONTRACT_VAL_EXP_YR:
							{
								str += "val_exp_yr";
								str += " " +op+ " ";
								str += codt_val.Format(VAR_DATEVALUEONLY, LANG_USER_DEFAULT);
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_UPDATE_DATE:
							{
								str += "update_date";
								str += " " +op+ " ";
								str += codt_val.Format(VAR_DATEVALUEONLY, LANG_USER_DEFAULT);
								str += " " +conj+ " ";
							}
							break;	
						};
					}
				}
				break;
			case CT_CSTRING:
				{
					get_cstring_ok = a->Get(itor, cstring_col, op, conj, str_val);
					if(get_cstring_ok)
					{
						switch(cstring_col)
						{
						case CONTRACT_AIRLINE_NAME:
							{
								str += "airline_name";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_DESC_CONTRACT1:
							{
								str += "desc_contract1";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_DESC_CONTRACT2:
							{
								str += "desc_contract2";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_GOOD_FOR_DETAIL:
							{
								str += "good_for_detail";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_TOUR_IT_CODE:
							{
								str += "tour_IT_code";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_TICKET_DESIGNATOR:
							{
								str += "ticket_designator";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_ENDORSEMENT_BOX:
							{
								str += "endorsement_box";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_PAY_METHOD:
							{
								str += "pay_method";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_DEAL_DESC1:
							{
								str += "deal_desc1";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_DEAL_DESC2:
							{
								str += "deal_desc2";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_SPECIFIC_FLIGHTS:
							{
								str += "specific_flights";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_SPFC_ROUTING_ORIGIN:
							{
								str += "spfc_routing_origin";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_SPFC_ROUTING_DEST:
							{
								str += "spfc_routing_dest";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_CLASS_OF_SERVICE:
							{
								str += "class_of_service";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_PTA:
							{
								str += "PTA";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_CODESHARE_CONNECTIONS:
							{
								str += "codeshare_connections";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_SPFC_EXCLUSIONS:
							{
								str += "spfc_exclusions";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_COMBINE_ABILITY:
							{
								str += "combine_ability";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_APOLLO_FRMT:
							{
								str += "apollo_frmt";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_SABRE_FRMT:
							{
								str += "sabre_frmt";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_MISC_NOTES:
							{
								str += "misc_notes";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_UPDATE_NAME:
							{
								str += "update_name";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_CONTRACT_NAME:
							{
								str += "contract_name";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						case CONTRACT_BLACKOUT_DATES:
							{
								str += "blackout_dates";
								str += " " +op+ " ";
								str += "'" +str_val+ "'";
								str += " " +conj+ " ";
							}
							break;
						};
					}
				}
				break;
			case CT_BOOL:
				{
					get_bool_ok = a->Get(itor, bool_col, op, conj, bl_val);
				if(get_bool_ok)
				{
				switch(bool_col)
				{
				case CONTRACT_HOT_DEAL:
					{
						str += "hot_deal";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_AIR_DEALS_NOTEBOOK:
					{
						str += "air_deals_notebook";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_US:
					{
						str += "md_us";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_EU:
					{
						str += "md_eu";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_ASIA:
					{
						str += "md_asia";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_SOUTH_PACIFIC:
					{
						str += "md_south_pacific";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_SOUTH_AM:
					{
						str += "md_south_am";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_CENTRAL_AM:
					{
						str += "md_central_am";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_LATIN_AM:
					{
						str += "md_latin_am";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_MEXICO:
					{
						str += "md_mexico";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_AFRICA:
					{
						str += "md_africa";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_CA:
					{
						str += "md_ca";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_MIDDLE_EAST:
					{
						str += "md_middle_east";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_MD_RUSSIA:
					{
						str += "md_russia";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_GOOD_FOR_ALL:
					{
						str += "good_for_all";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_GOOD_FOR_MTALL:
					{
						str += "good_for_MTALL";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_GOOD_FOR_MTLELS:
					{
						str += "good_for_MTLELS";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_GOOD_FOR_MTCORP:
					{
						str += "good_for_MTCorp";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_GOOD_FOR_A4L:
					{
						str += "good_for_A4L";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_GOOD_FOR_ST:
					{
						str += "good_for_ST";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_PCOMM:
					{
						str += "type_deal_pcomm";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_PDISC:
					{
						str += "type_deal_pdisc";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_DCOMM:
					{
						str += "type_deal_dcomm";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_DDISC:
					{
						str += "type_deal_ddisc";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_ZONE:
					{
						str += "type_deal_zone";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_BULK:
					{
						str += "type_deal_bulk";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_NET:
					{
						str += "type_deal_net";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_UPGRADE:
					{
						str += "type_deal_upgrade";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_TWO_ONE:
					{
						str += "type_deal_two_one";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_TYPE_DEAL_OTHER:
					{
						str += "type_deal_other";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_VAL_START:
					{
						str += "val_start";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				case CONTRACT_VAL_COMPLETE:
					{
						str += "val_complete";
						str += " " +op+ " ";
						switch(bl_val)
						{
						case TRUE:	str += "TRUE";
							break;
						case FALSE:	str += "FALSE";
							break;
						};
						str += " " +conj+ " ";
					}
					break;
				};
				}
				
				}
				break;
			};
			
		}
	}

	//suck off the last AND

	int length = str.GetLength();
	str = str.Left(length - 5);

	return str;



	

}

BOOL CFilter::ContractsFilter(CData * pDb, CAll * al)
{
	OldParams = pDb->m_contractsSet.m_nParams;
	pDb->m_contractsSet.m_nParams = 0;

	if(pDb->m_contractsSet.IsOpen())
		pDb->m_contractsSet.Close();

	pDb->m_contractsSet.m_strFilter = "";

	CString sql = BuildSQL(al);
	int length = sql.GetLength();

	pDb->m_contractsSet.Open(dbOpenDynaset, sql.GetBuffer(length), dbReadOnly);

	int count = pDb->m_contractsSet.GetRecordCount();

	pDb->m_contractsSet.m_nParams = OldParams;

	if(count == 0)
		return FALSE;
	else
		return TRUE;

}

BOOL CFilter::ContractsFilter(CData * pDb, CAll * al, BOOL cnt, int & count)
{
return FALSE;
}
