// Rich.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "Rich.h"

#include "Globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRich dialog


CRich::CRich(CWnd* pParent /*=NULL*/)
	: CDialog(CRich::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRich)
	m_column_name = _T("");
	//}}AFX_DATA_INIT

	retval = "\\par\\par";
	retval2 = "\\par\\par\\par";
}


void CRich::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRich)
		DDX_Control(pDX, IDC_MAIN, ctr_main);
		DDX_Text(pDX, IDC_MAIN, m_main);
		DDX_Control(pDX, IDC_INV, ctr_inv);
		DDX_Text(pDX, IDC_INV, m_inv);
	DDX_Text(pDX, IDC_COLUMN_NAMES, m_column_name);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRich, CDialog)
	//{{AFX_MSG_MAP(CRich)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRich message handlers

void CRich::CreateTitle(CString str)
{
	m_inv = str;
	UpdateData(FALSE);

	



}

void CRich::FormatCtrl(CRichEditCtrl *ctrl, long min, long max, int frmt)
{
	CHARFORMAT cr;
	
	ctr_inv.SetSel(min, max);


	ctr_inv.GetSelectionCharFormat(cr);
	cr.cbSize = sizeof(cr);

	switch(frmt)
	{
	case BOLD:
		{
			if(cr.dwMask & CFM_BOLD)
			{
				cr.dwMask ^= CFM_BOLD;
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects ^= CFE_BOLD;
				ctr_inv.SetSelectionCharFormat(cr);
			}
			else
			{
				cr.dwMask |= CFM_BOLD;
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects |= CFE_BOLD;
				ctr_inv.SetSelectionCharFormat(cr);
			}
		}
		break;
	case ITALIC:
		{
			if(cr.dwMask & CFM_ITALIC)
			{
				cr.dwMask ^= CFM_ITALIC;
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects ^= CFE_ITALIC;
				ctr_inv.SetSelectionCharFormat(cr);
			}
			else
			{
				cr.dwMask |= CFM_ITALIC;
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects |= CFE_ITALIC;
				ctr_inv.SetSelectionCharFormat(cr);
			}
		}
		break;
	case UNDERLINE:
		{
			if(cr.dwMask & CFM_UNDERLINE)
			{
				cr.dwMask ^= CFM_UNDERLINE;
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects ^= CFE_UNDERLINE;
				ctr_inv.SetSelectionCharFormat(cr);
			}
			else
			{
				cr.dwMask |= CFM_UNDERLINE;
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects |= CFE_UNDERLINE;
				ctr_inv.SetSelectionCharFormat(cr);
			}
		}
		break;
	case SIZEP:
		{	
			ctr_inv.GetSelectionCharFormat(cr);
			cr.yHeight = cr.yHeight + 30;
			ctr_inv.SetSelectionCharFormat(cr);			
		}
		break;
	case SIZEM:
		{	
			ctr_inv.GetSelectionCharFormat(cr);
			cr.yHeight = cr.yHeight - 30;
			ctr_inv.SetSelectionCharFormat(cr);			
		}
		break;
		case BLACK:
			{		
				ctr_inv.GetSelectionCharFormat(cr);
				cr.dwEffects ^= CFE_AUTOCOLOR;
				cr.crTextColor = 0x00000000;
				ctr_inv.SetSelectionCharFormat(cr);
				ctr_inv.SetFocus();
		}

	};	
}

CHARRANGE CRich::FindEndPos(CRichEditCtrl * ctrl)
{
	CHARRANGE cr;
	long txtlength = ctrl->GetTextLength();

	cr.cpMin = txtlength;
	cr.cpMax = txtlength;


	return cr;
}

void CRich::RTFtoTEXT(CRichEditCtrl * ctrl)
{
	UpdateData(FALSE);

	//stream out as text then stream in as RTF 

	EDITSTREAM es;
	CString file_name = "rtot.rtf";
	CFile rtfFile(TEXT(file_name), CFile::modeCreate|CFile::modeWrite);
	es.dwCookie = (DWORD) &rtfFile;
	es.pfnCallback = EditStreamOutCallback;
	ctrl->StreamOut(SF_RTF, es);

	rtfFile.Close();

	rtfFile.Open(TEXT(file_name), CFile::modeRead);
	es.dwCookie = (DWORD) &rtfFile;
	es.pfnCallback = EditStreamInCallback;
	ctrl->StreamIn(SF_TEXT, es);
	UpdateData(TRUE);

	rtfFile.Close();
	rtfFile.Remove(file_name);


}
void CRich::TEXTtoRTF(CRichEditCtrl * ctrl)
{
	UpdateData(FALSE);

	//stream out as text then stream in as RTF 

	EDITSTREAM es;
	CString file_name = "ttor.rtf";
	CFile rtfFile(TEXT(file_name), CFile::modeCreate|CFile::modeWrite);
	es.dwCookie = (DWORD) &rtfFile;
	es.pfnCallback = EditStreamOutCallback;
	ctrl->StreamOut(SF_TEXT, es);

	rtfFile.Close();

	rtfFile.Open(TEXT(file_name), CFile::modeRead);
	es.dwCookie = (DWORD) &rtfFile;
	es.pfnCallback = EditStreamInCallback;
	ctrl->StreamIn(SF_RTF, es);
	UpdateData(TRUE);

	rtfFile.Close();
	rtfFile.Remove(file_name);


}
void CRich::StreamTo(CRichEditCtrl * one, CRichEditCtrl * two)
{
	UpdateData(FALSE);

	//stream out as text then stream in as RTF 

	EDITSTREAM es;
	CString file_name = "otot.rtf";
	CFile rtfFile(TEXT(file_name), CFile::modeCreate|CFile::modeWrite);
	es.dwCookie = (DWORD) &rtfFile;
	es.pfnCallback = EditStreamOutCallback;
	one->StreamOut(SF_RTF, es);

	rtfFile.Close();

	//set selection in two to last;

	CHARRANGE cr = FindEndPos(two);
	two->SetSel(cr);

	rtfFile.Open(TEXT(file_name), CFile::modeRead);
	es.dwCookie = (DWORD) &rtfFile;
	es.pfnCallback = EditStreamInCallback;
	two->StreamIn(SF_RTF | SFF_SELECTION, es);
	UpdateData(TRUE);

	rtfFile.Close();
	rtfFile.Remove(file_name);
}

void CRich::AddReturn(int where, CString str, CRichEditCtrl *ctrl)
{
	
	RTFtoTEXT(ctrl);



	CString ctr, ret;
	if(ctrl == &ctr_inv)
		ctr = m_inv;
	if(ctrl == &ctr_main)
		ctr = m_main;

	int ctrl_length = ctr.GetLength();
	int str_length = str.GetLength();
	int pos = ctr.Find(str);

	int lft, rt;

	if(where == AFTER)
	{
		lft = pos + str_length;
		rt = ctrl_length - lft;
		ret = retval;
	}
	else if(where == BEFORE)
	{
		lft = pos;
		rt = ctrl_length - lft;
		ret = retval2;
	}

	CString left, right;

	left = ctr.Left(lft);
	right = ctr.Right(rt);

	
	left += ret;
	left += right;
	ctr = left;

	if(ctrl == &ctr_inv)
		m_inv = ctr;
	else if(ctrl == &ctr_main)
		m_main = ctr;

	TEXTtoRTF(ctrl);
}

DWORD CALLBACK CRich::EditStreamInCallback(DWORD dwCookie, 
    LPBYTE pbBuff, LONG cb, LONG FAR *pcb)
{
	CFile* pFile = (CFile*) dwCookie;

	*pcb = pFile->Read(pbBuff, cb);

	return 0;
}
DWORD CALLBACK CRich::EditStreamOutCallback(DWORD dwCookie, 
    LPBYTE pbBuff, LONG cb, LONG FAR *pcb)
{
	CFile* pFile = (CFile*) dwCookie;

	pFile->Write(pbBuff, cb);
	*pcb = cb;
	return 0;
}



BOOL CRich::OnInitDialog()
{
	CDialog::OnInitDialog();

	ColumnCheck();

	//UpdateData(FALSE);

	return TRUE;
}

void CRich::ColumnCheck()
{
	m_column_name = title;
	if(title == "Update Name")
	{
		
		m_main = store_data;
		UpdateData(FALSE);
	}
	else if(title == "Contract Name")
	{
		m_main = store_data;
		UpdateData(FALSE);
	}
	else if(title == "Description of Contract 1")
	{
		m_main = store_data;
		UpdateData(FALSE);
	}
	else if(title == "Description of Contract 2")
	{
		m_main = store_data;
		UpdateData(FALSE);
	}
	else if(title == "Good for Detail")
	{
		m_main = store_data;
		UpdateData(FALSE);
	}
	else
	{
		m_main = store_data;
		TEXTtoRTF(&ctr_main);
	}
}

void CRich::OnClose() 
{
	EndDialog(0);	
}
