// Search.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "Search.h"

#include "Globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearch dialog


CSearch::CSearch(CWnd* pParent /*=NULL*/)
	: CDialog(CSearch::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearch)
	m_DestinationAsia = FALSE;
	m_DestinationCentralAmerica = FALSE;
	m_DestinationEurope = FALSE;
	m_DestinationMexico = FALSE;
	m_DestinationMiddleEast = FALSE;
	m_DestinationRussia = FALSE;
	m_DestinationSouthAmerica = FALSE;
	m_DestinationSouthPacific = FALSE;
	m_DestinationUS = FALSE;
	m_DestinationCanada = FALSE;
	m_DestinationLatinAmerica = FALSE;
	m_GoodforA4L = FALSE;
	m_GoodforAll = FALSE;
	m_GoodforMTAll = FALSE;
	m_GoodforMTCorp = FALSE;
	m_GoodforMTLeis = FALSE;
	m_GoodforST = FALSE;
	m_HotDeals = FALSE;
	m_DealBulk = FALSE;
	m_DealDolComm = FALSE;
	m_DealDolDisc = FALSE;
	m_DealNet = FALSE;
	m_DealPerComm = FALSE;
	m_DealPerDisc = FALSE;
	m_DealUpgrade = FALSE;
	m_DealZone = FALSE;
	m_airline_name = _T("");
	m_contract_name = _T("");
	m_DestinationAfrica = FALSE;
	m_DealOther = FALSE;
	m_Deal2for1 = FALSE;
	//}}AFX_DATA_INIT
}


void CSearch::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearch)
	DDX_Control(pDX, IDC_CONTRACTNAME_COMBO, c_ContractName);
	DDX_Control(pDX, IDC_AIRLINENAME_COMBO, c_AirlineName);
	DDX_Check(pDX, IDC_ASIA_CHECK, m_DestinationAsia);
	DDX_Check(pDX, IDC_CENTRALAMERICA_CHECK, m_DestinationCentralAmerica);
	DDX_Check(pDX, IDC_EUROPE_CHECK, m_DestinationEurope);
	DDX_Check(pDX, IDC_MEXICO_CHECK, m_DestinationMexico);
	DDX_Check(pDX, IDC_MIDDLEEAST_CHECK, m_DestinationMiddleEast);
	DDX_Check(pDX, IDC_RUSSIA_CHECK, m_DestinationRussia);
	DDX_Check(pDX, IDC_SOUTHAMERICA_CHECK, m_DestinationSouthAmerica);
	DDX_Check(pDX, IDC_SOUTHPACIFIC_CHECK, m_DestinationSouthPacific);
	DDX_Check(pDX, IDC_US_CHECK, m_DestinationUS);
	DDX_Check(pDX, IDC_CANADA_CHECK, m_DestinationCanada);
	DDX_Check(pDX, IDC_LATINAMERICA_CHECK, m_DestinationLatinAmerica);
	DDX_Check(pDX, IDC_GOODFOR_A4L_CHECK, m_GoodforA4L);
	DDX_Check(pDX, IDC_GOODFOR_ALL_CHECK, m_GoodforAll);
	DDX_Check(pDX, IDC_GOODFOR_MTALL_CHECK, m_GoodforMTAll);
	DDX_Check(pDX, IDC_GOODFOR_MTCORP_CHECK, m_GoodforMTCorp);
	DDX_Check(pDX, IDC_GOODFOR_MTLEIS_CHECK, m_GoodforMTLeis);
	DDX_Check(pDX, IDC_GOODFOR_ST_CHECK, m_GoodforST);
	DDX_Check(pDX, IDC_HOTDEALS_CHECK, m_HotDeals);
	DDX_Check(pDX, IDC_TYPEDEAL_BULK_CHECK, m_DealBulk);
	DDX_Check(pDX, IDC_TYPEDEAL_DOLCOMM_CHECK, m_DealDolComm);
	DDX_Check(pDX, IDC_TYPEDEAL_DOLDISC_CHECK, m_DealDolDisc);
	DDX_Check(pDX, IDC_TYPEDEAL_NET_CHECK, m_DealNet);
	DDX_Check(pDX, IDC_TYPEDEAL_PERCOMM_CHECK, m_DealPerComm);
	DDX_Check(pDX, IDC_TYPEDEAL_PERDISC_CHECK, m_DealPerDisc);
	DDX_Check(pDX, IDC_TYPEDEAL_UPGRADE_CHECK, m_DealUpgrade);
	DDX_Check(pDX, IDC_TYPEDEAL_ZONE_CHECK, m_DealZone);
	DDX_CBString(pDX, IDC_AIRLINENAME_COMBO, m_airline_name);
	DDX_CBString(pDX, IDC_CONTRACTNAME_COMBO, m_contract_name);
	DDX_Check(pDX, IDC_AFRICA_CHECK, m_DestinationAfrica);
	DDX_Check(pDX, IDC_TYPEDEAL_OTHER_CHECK, m_DealOther);
	DDX_Check(pDX, IDC_TYPEDEAL_TWOFORONE_CHECK, m_Deal2for1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearch, CDialog)
	//{{AFX_MSG_MAP(CSearch)
	ON_BN_CLICKED(IDC_CANCEL_BUTTON, OnCancelButton)
	ON_BN_CLICKED(IDC_DOSEARCH_BUTTON, OnDosearchButton)
	ON_BN_CLICKED(IDC_HOTDEALS_CHECK, OnHotdealsCheck)
	ON_EN_KILLFOCUS(IDC_SEARCHFIRSTTICKETDATE_EDIT, OnKillfocusSearchfirstticketdateEdit)
	ON_CBN_SELCHANGE(IDC_AIRLINENAME_COMBO, OnSelchangeAirlinenameCombo)
	ON_CBN_SELCHANGE(IDC_CONTRACTNAME_COMBO, OnSelchangeContractnameCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearch message handlers

void CSearch::OnCancelButton() 
{
	// closing dialog
	if(!pData->m_contractsSet.IsOpen())
		pData->m_contractsSet.Open();
	EndDialog(0);	
}


void CSearch::OnDosearchButton() 
{
	UpdateData(TRUE);

	//done with radios now doing check boxes ugh!! 
	//actually I will create a seperate f() for this
	CheckCreate();

	BOOL flt_ok =	pFlt->ContractsFilter(pData, &all);

	if(flt_ok)
		EndDialog(1);
	else
		MessageBox("Your search criterea is invalid.  Please try agian.");

}

void CSearch::OnHotdealsCheck() 
{

}

void CSearch::OnKillfocusSearchfirstticketdateEdit() 
{

}

void CSearch::OnSelchangeAirlinenameCombo() 
{
	all.Initialize();
	int sel = 	c_AirlineName.GetCurSel();
	CString aname;
	BOOL flt_ok;

	if(sel != CB_ERR)
		c_AirlineName.GetLBText(sel, aname);
	else
		aname = "ALL AIRLINES";

	
	if (aname != "ALL AIRLINES")
	{	
		// selecting first record that meet criteria		
		flt_ok = pFlt->ContractsFilter(pData, "airline_name", "=", aname);

		if(flt_ok)
		{
			//load contracts CB
			c_ContractName.ResetContent();
			c_ContractName.AddString("ALL CONTRACTS");
			pData->m_contractsSet.MoveFirst();
			while(!pData->m_contractsSet.IsEOF())
			{
				c_ContractName.AddString(pData->m_contractsSet.m_contract_name);
				pData->m_contractsSet.MoveNext();
			}

			//assign to string creation thing
			all.Add(CONTRACT_AIRLINE_NAME, aname);
	

			// enabling contract combobox
			c_ContractName.EnableWindow(TRUE);

			// setting default
			m_contract_name = _T("ALL CONTRACTS");


			// updating the dialog
			UpdateData(FALSE);
		}
		else
			MessageBox("The airline name is invalid, please see your Administrator.");
	}	
}


void CSearch::OnSelchangeContractnameCombo() 
{
	all.Undo();
	int sel = c_ContractName.GetCurSel();
	CString cname;

	if(sel != CB_ERR)
	{
		c_ContractName.GetLBText(sel, cname);
		all.Add(CONTRACT_CONTRACT_NAME, cname);
	}
}


void CSearch::CheckCreate()
{
	if(m_DestinationAfrica)
		all.Add(CONTRACT_MD_AFRICA, m_DestinationAfrica);	
	if(m_DestinationAsia)
		all.Add(CONTRACT_MD_ASIA, m_DestinationAsia);	
	if(m_DestinationCanada)
		all.Add(CONTRACT_MD_CA, m_DestinationCanada);	
	if(m_DestinationCentralAmerica)
		all.Add(CONTRACT_MD_CENTRAL_AM, m_DestinationCentralAmerica);
	if(m_DestinationEurope)
		all.Add(CONTRACT_MD_EU, m_DestinationEurope);
	if(m_DestinationLatinAmerica)
		all.Add(CONTRACT_MD_LATIN_AM,m_DestinationLatinAmerica);
	if(m_DestinationMexico)
		all.Add(CONTRACT_MD_MEXICO,m_DestinationMexico);
	if(m_DestinationMiddleEast)
		all.Add(CONTRACT_MD_MIDDLE_EAST,m_DestinationMiddleEast);
	if(m_DestinationRussia)
		all.Add(CONTRACT_MD_RUSSIA,m_DestinationRussia);
	if(m_DestinationSouthAmerica)
		all.Add(CONTRACT_MD_SOUTH_AM,m_DestinationSouthAmerica);
	if(m_DestinationSouthPacific)
		all.Add(CONTRACT_MD_SOUTH_PACIFIC,m_DestinationSouthPacific);
	if(m_DestinationUS)
		all.Add(CONTRACT_MD_US,m_DestinationUS);
	if(m_GoodforA4L)
		all.Add(CONTRACT_GOOD_FOR_A4L,m_GoodforA4L);
	if(m_GoodforAll)
		all.Add(CONTRACT_GOOD_FOR_ALL,m_GoodforAll);
	if(m_GoodforMTAll)
		all.Add(CONTRACT_GOOD_FOR_MTALL,m_GoodforMTAll);
	if(m_GoodforMTCorp)
		all.Add(CONTRACT_GOOD_FOR_MTCORP,m_GoodforMTCorp);
	if(m_GoodforMTLeis)
		all.Add(CONTRACT_GOOD_FOR_MTLELS,m_GoodforMTLeis);
	if(m_GoodforST)
		all.Add(CONTRACT_GOOD_FOR_ST,m_GoodforST);
	if(m_HotDeals)
		all.Add(CONTRACT_HOT_DEAL,m_HotDeals);
	if(m_DealBulk)
		all.Add(CONTRACT_TYPE_DEAL_BULK,m_DealBulk);
	if(m_DealDolComm)
		all.Add(CONTRACT_TYPE_DEAL_DCOMM,m_DealDolComm);
	if(m_DealDolDisc)
		all.Add(CONTRACT_TYPE_DEAL_DDISC,m_DealDolDisc);
	if(m_DealNet)
		all.Add(CONTRACT_TYPE_DEAL_NET,m_DealNet);
	if(m_DealPerComm)
		all.Add(CONTRACT_TYPE_DEAL_PCOMM,m_DealPerComm);
	if(m_DealPerDisc)
		all.Add(CONTRACT_TYPE_DEAL_PDISC,m_DealPerDisc);
	if(m_DealUpgrade)
		all.Add(CONTRACT_TYPE_DEAL_UPGRADE,m_DealUpgrade);
	if(m_DealZone)
		all.Add(CONTRACT_TYPE_DEAL_ZONE,m_DealZone);

}

BOOL CSearch::OnInitDialog()
{
	CDialog::OnInitDialog();

	c_AirlineName.AddString("ALL AIRLINES");
	c_ContractName.AddString("ALL CONTRACTS");

	if(!pData->m_airline_nameSet.IsOpen())
		pData->m_airline_nameSet.Open();

	pData->m_airline_nameSet.MoveFirst();

	while(!pData->m_airline_nameSet.IsEOF())
	{
		c_AirlineName.AddString(pData->m_airline_nameSet.m_airline_name);
		pData->m_airline_nameSet.MoveNext();
	}

	// setting default display
	m_airline_name = _T("ALL AIRLINES");

	// updating the dialog
	UpdateData(FALSE);

	return TRUE;
}
