// daoContracts.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "daoContracts.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CdaoContracts

IMPLEMENT_DYNAMIC(CdaoContracts, CDaoRecordset)

CdaoContracts::CdaoContracts(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CdaoContracts)
	m_airline_name = _T("");
	m_desc_contract1 = _T("");
	m_desc_contract2 = _T("");
	m_hot_deal = FALSE;
	m_air_deals_notebook = FALSE;
	m_md_us = FALSE;
	m_md_eu = FALSE;
	m_md_asia = FALSE;
	m_md_south_pacific = FALSE;
	m_md_south_am = FALSE;
	m_md_central_am = FALSE;
	m_md_latin_am = FALSE;
	m_md_mexico = FALSE;
	m_md_africa = FALSE;
	m_md_ca = FALSE;
	m_md_middle_east = FALSE;
	m_md_russia = FALSE;
	m_good_for_all = FALSE;
	m_good_for_MTALL = FALSE;
	m_good_for_MTLELS = FALSE;
	m_good_for_MTCorp = FALSE;
	m_good_for_A4L = FALSE;
	m_good_for_ST = FALSE;
	m_good_for_detail = _T("");
	m_type_deal_pcomm = FALSE;
	m_type_deal_pdisc = FALSE;
	m_type_deal_dcomm = FALSE;
	m_type_deal_ddisc = FALSE;
	m_type_deal_zone = FALSE;
	m_type_deal_bulk = FALSE;
	m_type_deal_net = FALSE;
	m_type_deal_upgrade = FALSE;
	m_type_deal_two_one = FALSE;
	m_type_deal_other = FALSE;
	m_tour_IT_code = _T("");
	m_val_start = FALSE;
	m_val_complete = FALSE;
	m_ticket_designator = _T("");
	m_endorsement_box = _T("");
	m_pay_method = _T("");
	m_deal_desc1 = _T("");
	m_deal_desc2 = _T("");
	m_specific_flights = _T("");
	m_spfc_routing_origin = _T("");
	m_spfc_routing_dest = _T("");
	m_class_of_service = _T("");
	m_PTA = _T("");
	m_codeshare_connections = _T("");
	m_spfc_exclusions = _T("");
	m_combine_ability = _T("");
	m_apollo_frmt = _T("");
	m_sabre_frmt = _T("");
	m_misc_notes = _T("");
	m_update_name = _T("");
	m_contract_id = 0;
	m_contract_name = _T("");
	m_blackout_dates = _T("");
	m_nFields = 63;
	m_nParams = 39;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CdaoContracts::GetDefaultDBName()
{
	return _T("c:\\apps\\Airdeals\\contracts.mdb");
}

CString CdaoContracts::GetDefaultSQL()
{
	return _T("[contracts]");
}

void CdaoContracts::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CdaoContracts)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[airline_name]"), m_airline_name);
	DFX_Text(pFX, _T("[desc_contract1]"), m_desc_contract1);
	DFX_Text(pFX, _T("[desc_contract2]"), m_desc_contract2);
	DFX_Bool(pFX, _T("[hot_deal]"), m_hot_deal);
	DFX_Bool(pFX, _T("[air_deals_notebook]"), m_air_deals_notebook);
	DFX_Bool(pFX, _T("[md_us]"), m_md_us);
	DFX_Bool(pFX, _T("[md_eu]"), m_md_eu);
	DFX_Bool(pFX, _T("[md_asia]"), m_md_asia);
	DFX_Bool(pFX, _T("[md_south_pacific]"), m_md_south_pacific);
	DFX_Bool(pFX, _T("[md_south_am]"), m_md_south_am);
	DFX_Bool(pFX, _T("[md_central_am]"), m_md_central_am);
	DFX_Bool(pFX, _T("[md_latin_am]"), m_md_latin_am);
	DFX_Bool(pFX, _T("[md_mexico]"), m_md_mexico);
	DFX_Bool(pFX, _T("[md_africa]"), m_md_africa);
	DFX_Bool(pFX, _T("[md_ca]"), m_md_ca);
	DFX_Bool(pFX, _T("[md_middle_east]"), m_md_middle_east);
	DFX_Bool(pFX, _T("[md_russia]"), m_md_russia);
	DFX_Bool(pFX, _T("[good_for_all]"), m_good_for_all);
	DFX_Bool(pFX, _T("[good_for_MTALL]"), m_good_for_MTALL);
	DFX_Bool(pFX, _T("[good_for_MTLELS]"), m_good_for_MTLELS);
	DFX_Bool(pFX, _T("[good_for_MTCorp]"), m_good_for_MTCorp);
	DFX_Bool(pFX, _T("[good_for_A4L]"), m_good_for_A4L);
	DFX_Bool(pFX, _T("[good_for_ST]"), m_good_for_ST);
	DFX_Text(pFX, _T("[good_for_detail]"), m_good_for_detail);
	DFX_Bool(pFX, _T("[type_deal_pcomm]"), m_type_deal_pcomm);
	DFX_Bool(pFX, _T("[type_deal_pdisc]"), m_type_deal_pdisc);
	DFX_Bool(pFX, _T("[type_deal_dcomm]"), m_type_deal_dcomm);
	DFX_Bool(pFX, _T("[type_deal_ddisc]"), m_type_deal_ddisc);
	DFX_Bool(pFX, _T("[type_deal_zone]"), m_type_deal_zone);
	DFX_Bool(pFX, _T("[type_deal_bulk]"), m_type_deal_bulk);
	DFX_Bool(pFX, _T("[type_deal_net]"), m_type_deal_net);
	DFX_Bool(pFX, _T("[type_deal_upgrade]"), m_type_deal_upgrade);
	DFX_Bool(pFX, _T("[type_deal_two_one]"), m_type_deal_two_one);
	DFX_Bool(pFX, _T("[type_deal_other]"), m_type_deal_other);
	DFX_Text(pFX, _T("[tour_IT_code]"), m_tour_IT_code);
	DFX_DateTime(pFX, _T("[val_first_tckt]"), m_val_first_tckt);
	DFX_DateTime(pFX, _T("[val_first_travel]"), m_val_first_travel);
	DFX_DateTime(pFX, _T("[val_last_tckt]"), m_val_last_tckt);
	DFX_DateTime(pFX, _T("[val_last_travel]"), m_val_last_travel);
	DFX_DateTime(pFX, _T("[val_exp_yr]"), m_val_exp_yr);
	DFX_Bool(pFX, _T("[val_start]"), m_val_start);
	DFX_Bool(pFX, _T("[val_complete]"), m_val_complete);
	DFX_Text(pFX, _T("[ticket_designator]"), m_ticket_designator);
	DFX_Text(pFX, _T("[endorsement_box]"), m_endorsement_box);
	DFX_Text(pFX, _T("[pay_method]"), m_pay_method);
	DFX_Text(pFX, _T("[deal_desc1]"), m_deal_desc1);
	DFX_Text(pFX, _T("[deal_desc2]"), m_deal_desc2);
	DFX_Text(pFX, _T("[specific_flights]"), m_specific_flights);
	DFX_Text(pFX, _T("[spfc_routing_origin]"), m_spfc_routing_origin);
	DFX_Text(pFX, _T("[spfc_routing_dest]"), m_spfc_routing_dest);
	DFX_Text(pFX, _T("[class_of_service]"), m_class_of_service);
	DFX_Text(pFX, _T("[PTA]"), m_PTA);
	DFX_Text(pFX, _T("[codeshare_connections]"), m_codeshare_connections);
	DFX_Text(pFX, _T("[spfc_exclusions]"), m_spfc_exclusions);
	DFX_Text(pFX, _T("[combine_ability]"), m_combine_ability);
	DFX_Text(pFX, _T("[apollo_frmt]"), m_apollo_frmt);
	DFX_Text(pFX, _T("[sabre_frmt]"), m_sabre_frmt);
	DFX_Text(pFX, _T("[misc_notes]"), m_misc_notes);
	DFX_DateTime(pFX, _T("[update_date]"), m_update_date);
	DFX_Text(pFX, _T("[update_name]"), m_update_name);
	DFX_Long(pFX, _T("[contract_id]"), m_contract_id);
	DFX_Text(pFX, _T("[contract_name]"), m_contract_name);
	DFX_Text(pFX, _T("[blackout_dates]"), m_blackout_dates);
	//}}AFX_FIELD_MAP
	//parameters
	pFX->SetFieldType(CDaoFieldExchange::param);
	DFX_Bool(pFX, _T("[hot_deal]"), m_hot_dealParam);
	DFX_Bool(pFX, _T("[air_deals_notebook]"), m_air_deals_notebookParam);
	DFX_Bool(pFX, _T("[md_us]"), m_md_usParam);
	DFX_Bool(pFX, _T("[md_eu]"), m_md_euParam);
	DFX_Bool(pFX, _T("[md_asia]"), m_md_asiaParam);
	DFX_Bool(pFX, _T("[md_south_pacific]"), m_md_south_pacificParam);
	DFX_Bool(pFX, _T("[md_south_am]"), m_md_south_amParam);
	DFX_Bool(pFX, _T("[md_central_am]"), m_md_central_amParam);
	DFX_Bool(pFX, _T("[md_latin_am]"), m_md_latin_amParam);
	DFX_Bool(pFX, _T("[md_mexico]"), m_md_mexicoParam);
	DFX_Bool(pFX, _T("[md_africa]"), m_md_africaParam);
	DFX_Bool(pFX, _T("[md_ca]"), m_md_caParam);
	DFX_Bool(pFX, _T("[md_middle_east]"), m_md_middle_eastParam);
	DFX_Bool(pFX, _T("[md_russia]"), m_md_russiaParam);
	DFX_Bool(pFX, _T("[good_for_all]"), m_good_for_allParam);
	DFX_Bool(pFX, _T("[good_for_MTALL]"), m_good_for_MTALLParam);
	DFX_Bool(pFX, _T("[good_for_MTLELS]"), m_good_for_MTLELSParam);
	DFX_Bool(pFX, _T("[good_for_MTCorp]"), m_good_for_MTCorpParam);
	DFX_Bool(pFX, _T("[good_for_A4L]"), m_good_for_A4LParam);
	DFX_Bool(pFX, _T("[good_for_ST]"), m_good_for_STParam);	
	DFX_Bool(pFX, _T("[type_deal_pcomm]"), m_type_deal_pcommParam);
	DFX_Bool(pFX, _T("[type_deal_pdisc]"), m_type_deal_pdiscParam);
	DFX_Bool(pFX, _T("[type_deal_dcomm]"), m_type_deal_dcommParam);
	DFX_Bool(pFX, _T("[type_deal_ddisc]"), m_type_deal_ddiscParam);
	DFX_Bool(pFX, _T("[type_deal_zone]"), m_type_deal_zoneParam);
	DFX_Bool(pFX, _T("[type_deal_bulk]"), m_type_deal_bulkParam);
	DFX_Bool(pFX, _T("[type_deal_net]"), m_type_deal_netParam);
	DFX_Bool(pFX, _T("[type_deal_upgrade]"), m_type_deal_upgradeParam);
	DFX_Bool(pFX, _T("[type_deal_two_one]"), m_type_deal_two_oneParam);
	DFX_Bool(pFX, _T("[type_deal_other]"), m_type_deal_otherParam);	
	DFX_DateTime(pFX, _T("[val_first_tckt]"), m_val_first_tcktParam);
	DFX_DateTime(pFX, _T("[val_first_travel]"), m_val_first_travelParam);
	DFX_DateTime(pFX, _T("[val_last_tckt]"), m_val_last_tcktParam);
	DFX_DateTime(pFX, _T("[val_last_travel]"), m_val_last_travelParam);
	DFX_DateTime(pFX, _T("[val_exp_yr]"), m_val_exp_yrParam);
	DFX_Bool(pFX, _T("[val_start]"), m_val_startParam);
	DFX_Bool(pFX, _T("[val_complete]"), m_val_completeParam);	
	DFX_DateTime(pFX, _T("[update_date]"), m_update_dateParam);	
	DFX_Long(pFX, _T("[contract_id]"), m_contract_idParam);
}

/////////////////////////////////////////////////////////////////////////////
// CdaoContracts diagnostics

#ifdef _DEBUG
void CdaoContracts::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CdaoContracts::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

void CdaoContracts::SetNull(int param)
{
	int itor;

	for(itor = 0; itor < m_nParams; itor++)
	{
		if(itor != param)
			SetParamValueNull(itor);
	}
}
